Subject: bug#42149: Substring and flex completion ignore implicit trailing ‘any’

From: Dario Gjorgjevski <[email-masked]>
Date: Mon, 28 Dec 2020 20:48:50 +0100

>> In the example you show, I think overlapping *is* as good a behavior as
>> any other (and the code is careful to to replace one face with the
>> other
>
> I agree with this general idea.  I think we have to be careful to write
> tests in terms of user experience as much as possible.  For example, in
> the very latest version of the code I pushed, I still have one of
> Dario's original tests failing (down to only two now).

Makes sense.  I had misunderstood the purpose of the face.  Overlapping
is indeed fine -- for all I care, we can also avoid putting it
altogether in cases where there is no _first character to type_ (without
moving point).  But again, the current behavior is OK.

In that case, the tests should be changed.

>>> This is good (consecutive `any` can introduce serious performance
>>> bugs because of our backtracing regexp matcher).  Other than
>>> improving performance, have you found other effects?
>>
>> Yes, the presence of multiple consecutive wildcards invalidates the
>> aforementioned assumption of completion-pcm--hilit-commonality that
>> the match is of the form
>>
>>     <hole><match><hole><match>...<hole>
>
> Makes sense, thank you.

I think this elimination of consecutive `any' should also be included in
João’s branch.

Best regards,
Dario

-- 
$ keyserver=hkps://hkps.pool.sks-keyservers.net
$ keyid=744A4F0B4F1C9371
$ gpg --keyserver $keyserver --search-keys $keyid